#include <bits/stdc++.h>

using namespace std;

int main()
{
    cin.tie(0);
    ios_base::sync_with_stdio(false);

    int t;

    cin>>t;

    int n,m,s;
    while(t--){
        cin>>n>>m>>s;

        vector<int> targets(s);

        for(int i=0;i<s;i++){
            cin>>targets[i];
            targets[i]--;
        }
        sort(targets.begin(),targets.end());

        vector<pair<int,int>> a(m);

        int x,y;
        for(int i=0;i<m;i++){
            cin>>x>>y;
            x--;
            y--;
            a[i] = {x,y};
        }


        cout<<"-1"<<'\n';


    }

    return 0;
}